#!/bin/ksh

levels=$1

if [[ -z $levels ]]
then
    print -u2 "usage: new-driver.ksh <levels>"
    exit 0
fi

new-recurse.ksh $levels | sort | uniq -c |

awk '

BEGIN { SUBSEP = ",";
    scale = 2;
}

$1 ~ /1/ {
sub(/\)<=>\(/, ",", $2);
sub(/\(/, "", $2);
sub(/\)/, "", $2);
split($2, a, /,/);
if (a[1] > a[3] || a[2] > a[4]) {
    t = a[1];
    a[1] = a[3];
    a[3] = t;
    t = a[2];
    a[2] = a[4];
    a[4] = t;
}
edge[a[1],a[2],a[3],a[4]]=1;
}

END {
    for (e in edge) {
        break;
    }

    print "%!PS";
    print "newpath 250 300 moveto";

    split(e, a, /,/);
    x_old = a[1];
    y_old = a[2];
    x = a[3];
    y = a[4];

    while (1)
    {
        printf("%s %s rlineto\n", (x-x_old)*scale, (y-y_old)*scale);

        x_old = x;
        y_old = y;

        delete edge[e];
        e = "empty";

        x_new = x;
        y_new = y;

        ind = x SUBSEP y SUBSEP x+1 SUBSEP y;
        if ( ind in edge) { e = ind; x_new = x+1; }

        ind = x SUBSEP y SUBSEP x SUBSEP y+1;
        if ( ind in edge) { e = ind; y_new = y+1; }

        ind = x-1 SUBSEP y SUBSEP x SUBSEP y;
        if ( ind in edge) { e = ind; x_new = x-1; }

        ind = x SUBSEP y-1 SUBSEP x SUBSEP y;
        if ( ind in edge) { e = ind; y_new = y-1; }

        if (e ~ /empty/)
        {
            print "fill";
            exit(0);
        } else {
            x = x_new;
            y = y_new;
        }
    }
}

'